<?php

	class MySQL{ // MySQL
		var $db_connect; // DB handler
		var $result;

		function MySQL($dbarg=array()){
			$this->connect($dbarg['host'],$dbarg['user'],$dbarg['password']);
			$this->select_db($dbarg['dbname']);
		}

		function connect($host,$user,$password){
			$this->db_connect=mysql_connect($host,$user,$password);
			
			if(!$this->check_connect())
				$this->errmsg();
		}

		function select_db($database){
			if(!mysql_select_db($database))
				$this->errmsg();
		}

		function query($query){
			$this->result = mysql_query($query);
		}

		function torow() {
			return mysql_fetch_row($this->result);
		}

		function close(){
			mysql_close($this->db_connect);
		}

		function check_connect(){
			if(is_resource($this->db_connect)==false)
				return false;
			else
				return true;
		}
		function errmsg(){
			die(mysql_errno()." : ".mysql_error());
		}
	}

	class Oci8{ // Oracle OCI8
		var $db_connect; // DB handler
		var $statement;

		function Oci8($dbarg=array()){
			$this->connect($dbarg['host'],$dbarg['user']
					,$dbarg['password']);
		}

		function connect($globalname,$user,$password){
			$this->db_connect=OCILogon($user,$password,$globalname);
		}

		function select_db($database){
		}

		function query($query){
			$this->statement = OCIParse($this->db_connect,$query);
			OCIExecute($this->statement);
		}

		function torow() {
			OCIFetchInto($this->statement,&$result);
			return $result;
		}
		function toarray() {
			OCIFetchInto($this->statement,&$result);
			$ncols=OCINumCols($this->statement);

			for($i=1;$i<=$ncols;$i++)
				$row[OCIColumnName($this->statement,$i)]=$result[$i-1];

			return $row;
		}

		function close(){
			OCIFreeStatement($this->statement);
			OCILogoff($this->db_connect);
		}

		function check_connect(){
		}
		function errmsg(){
		}
	}

	class PostgreSQL{ // PostgreSQL
		var $db_connect; // DB handler
		var $result;

		function PostgreSQL($dbarg=array()){
			$this->connect($dbarg['host'],$dbarg['user'],
					$dbarg['password'],$dbarg['dbname']);
		}

		function connect($host,$user,$password,$database){
			$this->db_connect=pg_connect("host=$host user=$user password=$password dbname=$database");
		}

		function select_db($database){
		}

		function query($query){
			$this->result = pg_query($this->db_connect,$query);
		}

		function torow() {
			return pg_fetch_row($this->result);
		}
		function toarray() {
			return pg_fetch_array($this->result);
		}

		function close(){
			pg_close($this->db_connect);
		}

		function check_connect(){
		}
		function errmsg(){
		}
	}

	class DBCache {
		var $db; 
		function DBCache($config=array()){
			$dbarg = array(
					'host' => $config['db_host'],
					'user' => $config['db_user'],
					'password' => $config['db_password'],
					'dbname' => $config['db_name']
			);
			// DBtype
			// 0 MySQL
			// 1 PostgreSQL
			// 2 Oracle
			
			switch($config['dbtype']){
				case 1 : $this->db = new PostgreSQL($dbarg);break;
				case 2 : $this->db = new Oci8($dbarg);break;
				default : $this->db = new MySQL($dbarg);break;
			}
		}
		function savePage($page=array()){
			if($pageid=$this->existPage($page->name)){
				$this->db->query(
					"REPLACE INTO pages values ('$pageid',".
					"'".$page->body."')");
			}else{				
				$this->db->query(
					"INSERT INTO pages (content) values('".$page->body."')");
				$this->db->query(
					"SELECT max(pageid) FROM pages");
				$row = $this->db->torow();
				$id = $row[0];
				$this->db->query(
					"INSERT INTO pageinfo (pagename,utime,pageid) ".
					"VALUES ('".$page->name."',now(),$id)");
			}
		}
		function deletePage($pagename){
			$this->db->query(
				"SELECT pageid FROM pageinfo where pagename='$pagename'");
			$row = $this->db->torow();

			$this->db->query(
				"DELETE FROM pages WHERE pageid=".$row[0]);
			$this->db->query(
				"DELETE FROM pageinfo WHERE pageid=".$row[0]);
		}

		function renamePage($pagename,$new){
			$this->db->query(
				"UPDATE SET pagename='$new' FROM pageinfo WHERE ".
				"pagename='$pagename'");
		}

		function getBody($pagename=''){
			$this->db->query(
				"SELECT s1.content FROM pages s1,pageinfo s2 WHERE ".
				"s1.pageid = s2.pageid AND s2.pagename='$pagename'");
			$row = $this->db->torow();
			return $row[0];
		}
		function existPage($pagename){
			$this->db->query(
				"SELECT pageid FROM pageinfo WHERE pagename='$pagename'");
			$row = $this->db->torow();
			return $row[0];
		}
		function getPageLists(){
			$pages=array();
			$this->db->query(
				"SELECT pagename,utime FROM pageinfo" );
			if($mode==1)
				$needle_key=$this->pageToKeyname($needle);
			else $needle_key=$needle;

			while($row = $this->db->torow()){
//					$pagename = $this->keyToPagename($row[0]);
					$pagename = $row[0];
					$pages[] = $pagename;
//					$pages[$pagename] = $row[1];
			}
			return $pages;
		}
		function close(){
			$this->db->close();
		}
	}
	
?>
